function [Ups,FpnlA] = calculeseries(sysharmbal,Uo,Utj)

    H=sysharmbal.H;
    Neq=sysharmbal.Neq;

    % Matrice tangente systeme au point de depart
    dRdU = get_dRdU(sysharmbal,Uo);

    % Vecteur tangent exact a la branche au point de depart
    U1 = tangente(sysharmbal,dRdU,Uo);


    if (U1'*Utj) <0
      U1 = - U1;
    end


    % Matrice tangente de la MAN
    K = [dRdU ; (get_chemin(sysharmbal).*U1)'];
%invK = inv(K);
[LK,UK,pK,qK] = lu(K,'vector');

[neq, ninc] = size(dRdU);

pmax = get_ordre(sysharmbal);

Ups = zeros(ninc,pmax+1);

%
% Point de départ
% 

Ups(:,1) = Uo;

%        
% Premier Ordre   
%                 

Ups(:,2) = U1;

    %                 
    % Ordres suivants 
    %                 

    for p=2:pmax
        Fpnl = zeros(ninc,1);  
          
        for r=1:p-1
          Fpnl = Fpnl - [Q(sysharmbal,Ups(:,r+1),Ups(:,p-r+1),H,Neq) ; 0] ;
        end

    Ups(qK,p+1) = UK\(LK\Fpnl(pK)) ;
% Pour p=2 on a Ups = [U0, U1, U2]
    end


    % on calcule le second membre supplementaire
       FpnlA = zeros(neq,1);  
          
        for r=1:p
          FpnlA = FpnlA - Q(sysharmbal,Ups(:,r+1),Ups(:,p+2-r),H,Neq);
        end


disp(['branch sign : ',num2str(sign(prod(diag(UK))))]);

