% Computes the tangent matrix dRdU for a SYSREGTENS object

function dRdU = get_dRdU(sys,U)

global L_tens Lh_tens Q_tens Qh_tens


[neq1, ninc] = size(L_tens);
neq = sys.ninc-1;

dRdU = sparse([],[],[],ninc,neq,nnz(Q_tens)+nnz(L_tens));
  
for i=1:neq1
    Qi_sym=Q_tens(:,ninc*(i-1)+1:ninc*i)+Q_tens(:,ninc*(i-1)+1:ninc*i)';
    dRdU(:,i) = Qi_sym*sparse(U) ;
end
for i=1:neq-neq1
    dRdU(:,neq1+i) =  - Qh_tens(:,ninc*(i-1)+1:ninc*i)'*sparse(U) ;
end

dRdU = dRdU' + cat(1,L_tens,Lh_tens);
