% Returns the number of non-zero elements of the quadratic
% operator contribution to the tangent matrix : dQdU = U^t*Q + U^t*Q^t
% for a SYSTENSEUR object.

function nbelem = get_nbelem(systenseur)

global Q_tens


ninc = get_ninc(systenseur) ;
neq = get_neq(systenseur);


  dQdU = zeros(ninc,neq);
  
    for i=1:neq
        Qi_sym=Q_tens(:,ninc*(i-1)+1:ninc*i)+Q_tens(:,ninc*(i-1)+1:ninc*i)';
        dQdU(:,i) = Qi_sym*ones(ninc,1) ;
    end

% U=rand(ninc,1);
% 
% dQdU2 = reshape((Q_tens'*U)',[],2)';

 nbelem = nnz(dQdU);