function tron = TRONCON(sys,Uj,Utj,diaginfos)

global ML_stability;
global ML_algostab;

nbptstroncon = get_nbptstroncon(sys);

tron.ordre = get_ordre(sys);
tron.ninc = get_ninc(sys);
%tron.systype = get_systemtype(sys);
tron.dispcolors = diaginfos.dispcolors;
tron.dispvars = diaginfos.dispvars;
tron.seuil = 1;
tron.perturbation = diaginfos.perturbation;

tron.FpnlA = zeros(get_neq(sys),1);

tron.Ups = zeros(tron.ninc,0);

% Syntaxe : matrice nx2 ou n est le nobmre de courbes
% Dans la premiere colone on met les index des variables affichees en
% abscisse et la seconde correspond aux index des vars en ordonnee
nbcourbes = length( diaginfos.dispvars(:,1));

tron.nbcourbes = nbcourbes;

tron.X = zeros(0, nbcourbes); % Evaluation du paramatre axe abscisse
tron.Y = zeros(0, nbcourbes); % Evaluation du parametre axe ordonne
tron.A = zeros(0, nbcourbes); % valeurs de A pour chaques points de X et de Y

tron.Utj = Utj; % tangente approchee de depart du troncon;
tron.Uj = Uj; % point de depart du troncon;

tron.drawtype = diaginfos.drawtype;


% Analyse de la stabilit
if ML_stability ==  1

    tron.drawstab = diaginfos.drawstab;
    tron.stabvars = diaginfos.stabvars;
    tron.HH = diaginfos.stabvars(end);
    HH = tron.HH;
    
    if HH == 0
        
        if (length(diaginfos.stabvars) < 3)
            error('Le vecteur ML_varstab n''a pas les bonnes dimensions.');
        end
        
        nbddlstab = length(diaginfos.stabvars) - 1;
        
        if ML_algostab == 1
            nbddl = get_nbddlT(sys, nbddlstab);
        else
            nbddl = get_nbddlF(sys, nbddlstab);
        end
        
        tron.nbddl = nbddl;
        tron.eigen = zeros(nbptstroncon,nbddl);
        tron.vectors = zeros(nbptstroncon,nbddl*nbddl);
        tron.ddlstab = zeros(nbptstroncon,nbddlstab);
    else
        
        if (length(diaginfos.stabvars) < 4)
            error('Le vecteur ML_varstab n''a pas les bonnes dimensions.');
        end
        
        nbddlstab = length(diaginfos.stabvars) - 2;
        
        if ML_algostab == 1
            nbddl = get_nbddlT(sys, nbddlstab);
        else
            nbddl = get_nbddlF(sys, nbddlstab);
        end        
        
        tron.nbddl = nbddl;        
        
        if diaginfos.stabvars(end-1) == diaginfos.stabvars(end-2);
            tron.NeqHH0 = (tron.ninc-1) / (2*(tron.HH)+1);
        else
            tron.NeqHH0 = (tron.ninc-2) / (2*(tron.HH)+1);
        end
        
        tron.eigen = zeros(nbptstroncon,nbddl*(2*HH+1));
        tron.vectors = zeros(nbptstroncon,nbddl*nbddl*(2*HH+1));
        tron.ddlstab = zeros(nbptstroncon,(nbddlstab - 1)*(2*HH+1)+2);
    end
    
    tron.nbddlstab = nbddlstab;
    tron.stabcheck = zeros(nbptstroncon,1);   
    
end


tron = class(tron,'TRONCON');

[tron.Ups,tron.FpnlA] = calculeseries(sys,Uj,Utj);


% Analyse de la stabilit
if ML_stability ==  1
    
    [tron.ddlstab] = troncon_ddlstab(tron, get_seuil(sys), nbptstroncon);
    
    if ML_algostab == 1
        [tron.stabcheck,tron.eigen] = stabT(sys, get_ddlstab(tron), HH);
    else
        [tron.stabcheck,tron.eigen,tron.vectors] = stabF(sys, get_ddlstab(tron), HH);
    end
    
end
