function Hand=tracbarU_colharm(H,Neq,U,udisp,fig)

col1=[0 0.3 0.6];
col2=col1*0.6;

% Column vector test
% ==================

if size(udisp,2)>size(udisp,1)
  udisp=udisp';
end

if size(U,2)>size(U,1)
  U=U';
end
if size(U,2)>1
  U=U(:,1);
  disp('tracbarU: U should be a column vector')
end

% Plotting the bargraph
% =====================

if floor(fig)==fig
  figure(fig)
  clf
  hold on
else
  axes(fig)
  hold on
end

Utrac=[];
Hand=[];
Ndisp=length(udisp);

% Static component
% ----------------

Xtick=1:Ndisp;
hand=bar(Xtick,U(udisp));
Hand=[Hand hand];

% Harmonic components
% -------------------

for hh=1:H
  Xtick=(hh*Ndisp+1):((hh+1)*Ndisp);
  II=udisp+(2*hh-1)*Neq;
  amp=sqrt(U(II).^2+U(II+Neq).^2);
  hand=bar(Xtick,amp);
  Hand=[Hand hand];
end

set(Hand(1:2:end),'Facecolor',col1)
set(Hand(2:2:end),'Facecolor',col2)

% Labels
% ======

dH=ceil(H/10);
Htick=0:dH:H;

dX=Ndisp*dH;
Xtick=1:dX:(H+1)*Ndisp;
Hsize=length(Xtick);

Xtickstr=cell(1,Hsize);
Xtickstr{1}='H0';
for ii=2:Hsize
  Xtickstr{ii}=['H',num2str(Htick(ii))];
end

set(gca,'Xtick',Xtick,'XtickLabel',Xtickstr)
ylabel('Harmonics amplitude')
box on
