function Hand=tracbarU_multicol(H,Neq,U,udisp,fig)

% Colormap
% ========

col1=[0 0.3 0.6];
vec=linspace(.4,1,256);
vec=vec';
map=vec*col1;


% Column vector test
% ==================

if size(udisp,2)>size(udisp,1)
  udisp=udisp';
end

if size(U,2)>size(U,1)
  U=U';
end
if size(U,2)>1
  U=U(:,1);
  disp('tracbarU: U should be a column vector')
end

% Plotting the bargraph
% =====================

if floor(fig)==fig
  figure(fig)
  clf
  hold on
else
  axes(fig)
  hold on
end

Utrac=[];
Hand=[];
Ndisp=length(udisp);

% Utrac: matrix to be displayed
% =============================

Utrac=[];
Ndisp=length(udisp);

% Static component
% ----------------

I0=udisp;
Utrac=U(I0);

% Amplitude computations
% ----------------------

Iinit=1:2:(2*H-1);
Iinit=Iinit*Neq;
II=[];
for ii=1:length(udisp)
  II=[II udisp(ii)+Iinit];
end
II=sort(II);
II=II';

Utrac=[Utrac ; sqrt(U(II).^2+U(II+Neq).^2)];
Utrac=reshape(Utrac,Ndisp,H+1);
Utrac=Utrac';

% Labels
% ======

dH=ceil(H/10);
Htick=0:dH:H;

Xtick=1:dH:H+1;
Hsize=length(Xtick);

Xtickstr=cell(1,Hsize);
Xtickstr{1}='H0';
for ii=2:Hsize
  Xtickstr{ii}=['H',num2str(Htick(ii))];
end


Hand=bar(Utrac);
set(gca,'Xtick',Xtick,'XtickLabel',Xtickstr)
ylabel('Harmonics amplitude')
colormap(map)
box on